Index: trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1241)
+++ trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1242)
@@ -1544,6 +1486,5 @@
 	// TODO Remove this method!!
 	// Can just getItemsWithin be used?
-	public static Collection<Item> getItemsEnclosedBy(Frame frame, PolygonBounds poly)
-	{
+	public static Collection<Item> getItemsEnclosedBy(Frame frame, PolygonBounds poly) {
 		Collection<Item> contained = frame.getItemsWithin(poly);
 
@@ -1570,198 +1511,190 @@
 		return results;
 	}
+	
+	public static void CreateDefaultProfile(String profileFor, Frame profile) {
+		CreateDefaultProfile(profileFor, profile, null);
+	}
 
 	/**
-	 * Fills the given Frame with default profile tags
+	 * Copies the content from the default profile to the specified profile.
+	 * @param profileFor Name of profile that is destination of copy.
+	 * @param profile Profile being setup.
+	 * @param specifiedTextSettings text settings to provide a default value for in the new profile
+	 * @param specifiedGenericSettings generic settings to provide a default value for in the new profile
 	 */
-	public static void CreateDefaultProfile(String username, Frame profile)
-	{
-		Text title = profile.getTitleItem();
-		if (username.equals(UserSettings.DEFAULT_PROFILE_NAME)) {
+	public static void CreateDefaultProfile(String profileFor, Frame profile, 
+			Map<String, Setting> specifiedSettings) {
+		// If this is already the default profile then nothing (other than setting
+		// title) needs to be done.
+		Text titleItem = profile.getTitleItem();
+		Text title = titleItem;
+		if (!profileFor.equals(UserSettings.DEFAULT_PROFILE_NAME)) {
+			// If this profile is not the default profile, copy it from the default profile
+			// instead of generating a new profile
+			// (this allows the possibility of modifying the default profile and having any
+			// new profiles get those modifications)
+			Frame defaultFrame = FrameIO.LoadProfile(UserSettings.DEFAULT_PROFILE_NAME);
+			if (defaultFrame == null) {
+				try {
+					// If we do not have a default to copy, create one.
+					defaultFrame = FrameIO.CreateNewProfile(UserSettings.DEFAULT_PROFILE_NAME, null);
+				} catch (InvalidFramesetNameException invalidNameEx) {
+					MessageBay.errorMessage("Failed to create default profile named: "
+							+ UserSettings.DEFAULT_PROFILE_NAME + ".  "
+							+ "Profile names must start and end with a letter and must contain only letters and numbers.");
+					return;
+				} catch (ExistingFramesetException existingFramesetEx) {
+					MessageBay.errorMessage("Failed to create the desired default frameset: "
+							+ UserSettings.DEFAULT_PROFILE_NAME + ", "
+							+ "because it already exists.  This should never happen as we shouldn't be asking to create it if it already exists.");
+					return;
+				}
+			}
+
+			MessageBay.suppressMessages(true);
+			int lastNumber = FrameIO.getLastNumber(defaultFrame.getFramesetName());
+			for (int i = 1; i <= lastNumber; i++) {
+				// Load in next default, if it doesn't exist continue loop.
+				defaultFrame = FrameIO.LoadFrame(defaultFrame.getFramesetName() + i);
+				if (defaultFrame == null) {
+					continue;
+				}
+
+				// Create the next next (currently blank) profile frame.
+				// If there is frame gaps in the default (say if there is no 4.exp but there is
+				// a 5.exp) then retain those gaps.
+				// This way copied relative links work.
+				while (profile.getNumber() < defaultFrame.getNumber()) {
+					profile = FrameIO.CreateFrame(profile.getFramesetName(), null, null);
+				}
+				// Ensure we are working from a blank slate.
+				profile.reset();
+				profile.removeAllItems(profile.getAllItems());
+
+				// For each item on defaultFrame:
+				// 1. Set all items to be relatively linked so once copied their links correctly
+				// point to the frame on the created profile rather than the default profile.
+				// 2. Copy item from defaultFrame to the current profile frame being
+				// constructed.
+				// 3. Replace settings values of copied items with those specified in
+				// specifiedSettings (if present)
+				for (Item item : defaultFrame.getAllItems()) {
+					item.setRelativeLink();
+				}
+				profile.addAllItems(defaultFrame.getAllItems());
+				if (i == 1 && titleItem != null) {
+					titleItem.setText(profileFor + "'s Profile");
+				}
+				String category = profile.getTitle();
+				List<String> settingsKeys = null;
+				if (specifiedSettings != null) {
+					settingsKeys = specifiedSettings.keySet().stream().filter(key -> 
+						key.startsWith(category)).collect(Collectors.toList());
+				}
+				if (settingsKeys != null) {
+					for (String key: settingsKeys) {
+						Setting setting = specifiedSettings.get(key);
+						String name = setting.getName();
+						Text representation = setting.generateRepresentation(name.substring(0, 1).toUpperCase() + name.substring(1).toLowerCase(), profile.getFramesetName());
+						Collection<Text> canditates = profile.getTextItems();
+						canditates.removeIf(text -> !text.getText().startsWith(representation.getText().split(" ")[0]));
+						canditates.forEach(text -> {
+							Point backupPos = text.getPosition();
+							Item.DuplicateItem(representation, text);
+							text.setText(representation.getText());
+							text.setPosition(backupPos);
+						});
+					}
+				}
+				FrameIO.SaveFrame(profile);
+			}
+			MessageBay.suppressMessages(false);
+		} else {
 			title.setText("Default Profile Frame");
-		} else {
-			// if this profile is not the default profile, copy it from the default profile instead of generating a new profile
-			// (this allows the possibility of modifying the default profile and having any new profiles get those modifications)
-			Frame nextDefault = FrameIO.LoadProfile(UserSettings.DEFAULT_PROFILE_NAME);
-			if (nextDefault == null) {
-				try {
-					nextDefault = FrameIO.CreateNewProfile(UserSettings.DEFAULT_PROFILE_NAME);
-				} catch (Exception e) {
-					// TODO tell the user that there was a problem creating the
-					// profile frame and close nicely
-					e.printStackTrace();
-				}
-			}
-			// load profile frame and set title correctly
-			profile.reset();
-			profile.removeAllItems(profile.getAllItems());
-			// set relative link on all items so their links will correctly point to the page on the current profile rather than on the default profile
-			for(Item i : nextDefault.getAllItems()) {
-				i.setRelativeLink();
-			}
-			profile.addAllItems(ItemUtils.CopyItems(nextDefault.getAllItems()));
-			profile.setTitle(username + "'s Profile Frame");
-			FrameIO.SaveFrame(profile);
-
-			Frame nextProfile = profile;
-			MessageBay.suppressMessages(true);
-			while((nextDefault = FrameIO.LoadNext(nextDefault)) != null) {
-				// in case there are gaps in the frame numbering of the default profile (e.g. if a user has edited it),
-				// we need to replicate those gaps in the copied profile so the links will work correctly
-				while(nextProfile.getNumber() < nextDefault.getNumber()) {
-					nextProfile = FrameIO.CreateFrame(profile.getFramesetName(), null, null);
-				}
-				// if the new profile has a frame number higher than the current frame number in the default profile,
-				// the new profile must already exist, so just exit
-				// (TODO: should we wipe the frames instead?)
-				if(nextProfile.getNumber() > nextDefault.getNumber()) {
-					break;
-				}
-				nextProfile.reset();
-				nextProfile.removeAllItems(nextProfile.getAllItems());
-				// set relative link on all items so their links will correctly point to the page on the current profile rather than on the default profile
-				for(Item i : nextDefault.getAllItems()) {
-					i.setRelativeLink();
-				}
-				nextProfile.addAllItems(ItemUtils.CopyItems(nextDefault.getAllItems()));
-				FrameIO.SaveFrame(nextProfile);
-			}
-			MessageBay.suppressMessages(false);
-
-			return;
-		}
-
-		// int spacing = 50;
-		final int intialYPos = 75;
-		int xPos = 75;
-		int yPos = intialYPos;
-
-		// yPos += spacing;
-		// profile.addText(xPos, yPos, "@HomeFrame", null, profile.getName());
-		// yPos += spacing;
-		// String defaultFrameName = profile.getFramesetName() + "0";
-		// profile.addText(xPos, yPos, "@DefaultFrame", null, defaultFrameName);
-		// yPos += spacing;
-		//
-		// profile.addText(xPos, yPos, "@InitialWidth: "
-		// + UserSettings.InitialWidth, null);
-		// yPos += spacing;
-		//
-		// profile.addText(xPos, yPos, "@InitialHeight: "
-		// + UserSettings.InitialHeight, null);
-		// yPos += spacing;
-		//
-		// Text t = profile.addText(xPos, yPos, "@ItemTemplate", null);
-		// t.setColor(null);
-		//
-		// yPos += spacing;
-		// t = profile.addText(xPos, yPos, "@AnnotationTemplate", null);
-		// t.setColor(Color.gray);
-		//
-		// yPos += spacing;
-		// t = profile.addText(xPos, yPos, "@CommentTemplate", null);
-		// t.setColor(Color.green.darker());
-		//
-		// yPos += spacing;
-		// t = profile.addText(xPos, yPos, "@StatsTemplate", null);
-		// t.setColor(Color.BLACK);
-		// t.setBackgroundColor(new Color(0.9F, 0.9F, 0.9F));
-		// t.setFamily(Text.MONOSPACED_FONT);
-		// t.setSize(14);
-
-		Text t;
-
-		xPos = 300;
-		// yPos = intialYPos + spacing;
-		yPos = 100;
-
-		// Add documentation links
-		File helpDirectory = new File(FrameIO.HELP_PATH);
-		if (helpDirectory != null) {
-			File[] helpFramesets = helpDirectory.listFiles();
-			if (helpFramesets != null) {
-
-				// Add the title for the help index
-				Text help = profile.addText(xPos, yPos, "@Expeditee Help", null);
-				help.setSize(25);
-				help.setFontStyle("Bold");
-				help.setFamily("SansSerif");
-				help.setColor(TemplateSettings.ColorWheel.get()[3]);
-
-				xPos += 25;
-				System.out.println("Installing frameset: ");
-
-				boolean first_item = true;
-
-				for (File helpFrameset : helpFramesets) {
-					String framesetName = helpFrameset.getName();
-					if (!FrameIO.isValidFramesetName(framesetName)) {
-						continue;
+			int xPos = 300;
+			int yPos = 100;
+			Text t;
+			
+			// Add documentation links
+			File helpDirectory = new File(FrameIO.HELP_PATH);
+			if (helpDirectory != null) {
+				File[] helpFramesets = helpDirectory.listFiles();
+				if (helpFramesets != null) {
+
+					// Add the title for the help index
+					Text help = profile.addText(xPos, yPos, "@Expeditee Help", null);
+					help.setSize(25);
+					help.setFontStyle("Bold");
+					help.setFamily("SansSerif");
+					help.setColor(TemplateSettings.ColorWheel.get()[3]);
+
+					xPos += 25;
+					System.out.println("Installing frameset: ");
+
+					boolean first_item = true;
+					for (File helpFrameset : helpFramesets) {
+						String framesetName = helpFrameset.getName();
+						if (!FrameIO.isValidFramesetName(framesetName)) {
+							continue;
+						}
+
+						if (first_item) {
+							System.out.print("  " + framesetName);
+							first_item = false;
+						} else {
+							System.out.print(", " + framesetName);
+						}
+						System.out.flush();
+
+						Frame indexFrame = FrameIO.LoadFrame(framesetName + '1');
+						// Look through the folder for help index pages
+						if (indexFrame != null && ItemUtils.FindTag(indexFrame.getItems(), "@HelpIndex") != null) {
+							// yPos += spacing;
+							yPos += 30;
+							t = profile.addText(xPos, yPos, '@' + indexFrame.getFramesetName(), null);
+							t.setLink(indexFrame.getName());
+							t.setColor(Colour.GREY);
+						}
 					}
-
-					if (first_item) {
-						System.out.print("  " + framesetName);
-						first_item = false;
-					}
-					else {
-						System.out.print(", " + framesetName);
-					}
-					System.out.flush();
-
-					Frame indexFrame = FrameIO.LoadFrame(framesetName + '1');
-					// Look through the folder for help index pages
-					if (indexFrame != null
-							&& ItemUtils.FindTag(indexFrame.getItems(),
-									"@HelpIndex") != null) {
-						// yPos += spacing;
-						yPos += 30;
-						t = profile.addText(xPos, yPos,
-								'@' + indexFrame.getFramesetName(), null);
-						t.setLink(indexFrame.getName());
-						t.setColor(Colour.GREY);
-					}
-				}
-				System.out.println();
-			}
-		}
-
-		xPos = 50;
-		yPos = 100;
-
-		// Populate Start Pages and Settings
-		File framesetDirectory = new File(FrameIO.FRAME_PATH);
-
-		if (framesetDirectory.exists()) {
-			File[] startpagesFramesets = framesetDirectory.listFiles();
-
-			if (startpagesFramesets != null) {
-				// Add Start Page title
-				Text templates = profile.addText(xPos, yPos, "@Start Pages",
-						null);
-				templates.setSize(25);
-				templates.setFontStyle("Bold");
-				templates.setFamily("SansSerif");
-				templates.setColor(TemplateSettings.ColorWheel.get()[3]);
-
-				xPos += 25;
-
-				// Start Pages should be the first frame in its own frameset +
-				// frameset name should be present in FrameUtils.startPages[].
-				for (File startpagesFrameset : startpagesFramesets) {
-					String framesetName = startpagesFrameset.getName();
-
-					// Only add link if frameset is a startpage
-					for (int i = 0; i < startPages.length; i++) {
-						if (framesetName.equals(startPages[i])) {
-							Frame indexFrame = FrameIO
-									.LoadFrame(framesetName + '1');
-
-							// Add start page link
-							if (indexFrame != null) {
-								yPos += 30;
-								t = profile.addText(xPos, yPos,
-										'@' + indexFrame.getFramesetName(),
-										null);
-								t.setLink(indexFrame.getName());
-								t.setColor(Colour.GREY);
+					System.out.println();
+				}
+			}
+
+			xPos = 50;
+			yPos = 100;
+
+			// Populate Start Pages and Settings
+			File framesetDirectory = new File(FrameIO.FRAME_PATH);
+
+			if (framesetDirectory.exists()) {
+				File[] startpagesFramesets = framesetDirectory.listFiles();
+
+				if (startpagesFramesets != null) {
+					// Add Start Page title
+					Text templates = profile.addText(xPos, yPos, "@Start Pages", null);
+					templates.setSize(25);
+					templates.setFontStyle("Bold");
+					templates.setFamily("SansSerif");
+					templates.setColor(TemplateSettings.ColorWheel.get()[3]);
+
+					xPos += 25;
+
+					// Start Pages should be the first frame in its own frameset +
+					// frameset name should be present in FrameUtils.startPages[].
+					for (File startpagesFrameset : startpagesFramesets) {
+						String framesetName = startpagesFrameset.getName();
+
+						// Only add link if frameset is a startpage
+						for (int i = 0; i < startPages.length; i++) {
+							if (framesetName.equals(startPages[i])) {
+								Frame indexFrame = FrameIO.LoadFrame(framesetName + '1');
+
+								// Add start page link
+								if (indexFrame != null) {
+									yPos += 30;
+									t = profile.addText(xPos, yPos, '@' + indexFrame.getFramesetName(), null);
+									t.setLink(indexFrame.getName());
+									t.setColor(Colour.GREY);
+								}
 							}
 						}
@@ -1769,22 +1702,21 @@
 				}
 			}
-		}
-
-		FrameIO.SaveFrame(profile);
-
-		// Populate settings frameset
-		Settings.Init();
-		t = profile.addText(550, 100, "@Settings", null);
-		t.setSize((float) 25.0);
-		t.setFamily("SansSerif");
-		t.setFontStyle("Bold");
-		t.setColor(Colour.GREY);
-		Settings.generateSettingsTree(t);
-
-		FrameIO.SaveFrame(profile);
-	}
-
-	private static void checkTDFCItemWaiting(Frame currentFrame)
-	{
+
+			FrameIO.SaveFrame(profile);
+
+			// Populate settings frameset
+			Settings.Init();
+			t = profile.addText(550, 100, "@Settings", null);
+			t.setSize((float) 25.0);
+			t.setFamily("SansSerif");
+			t.setFontStyle("Bold");
+			t.setColor(Colour.GREY);
+			Settings.generateSettingsTree(t);
+
+			FrameIO.SaveFrame(profile);
+		}
+	}
+
+	private static void checkTDFCItemWaiting(Frame currentFrame) {
 		Item tdfcItem = FrameUtils.getTdfcItem();
 		// if there is a TDFC Item waiting
@@ -1806,16 +1738,13 @@
 	}
 
-	public static void setTdfcItem(Item _tdfcItem)
-	{
+	public static void setTdfcItem(Item _tdfcItem) {
 		FrameUtils._tdfcItem = _tdfcItem;
 	}
 
-	public static Item getTdfcItem()
-	{
+	public static Item getTdfcItem() {
 		return FrameUtils._tdfcItem;
 	}
 
-	public static void setLastEdited(Text lastEdited)
-	{
+	public static void setLastEdited(Text lastEdited) {
 		// If the lastEdited is being changed then check if its @i
 		Frame toReparse = null;
@@ -1834,20 +1763,12 @@
 					// around it
 					String text = LastEdited.getText();
-					if (text.startsWith("@i:")
-							&& !Character
-							.isDigit(text.charAt(text.length() - 1))) {
-						Collection<Item> enclosure = FrameUtils
-								.getEnclosingLineEnds(LastEdited.getPosition());
+					if (text.startsWith("@i:") && !Character.isDigit(text.charAt(text.length() - 1))) {
+						Collection<Item> enclosure = FrameUtils.getEnclosingLineEnds(LastEdited.getPosition());
 						if (enclosure != null) {
 							for (Item i : enclosure) {
 								if (i.isLineEnd() && i.isEnclosed()) {
-									DisplayController.getCurrentFrame().removeAllItems(
-											enclosure);
+									DisplayController.getCurrentFrame().removeAllItems(enclosure);
 									AxisAlignedBoxBounds rect = i.getEnclosedBox();
-									LastEdited
-									.setText(LastEdited.getText()
-											+ " "
-											+ Math.round(rect
-													.getWidth()));
+									LastEdited.setText(LastEdited.getText() + " " + Math.round(rect.getWidth()));
 									LastEdited.setPosition(rect.getTopLeft());
 									LastEdited.setThickness(i.getThickness());
@@ -1892,106 +1813,121 @@
 		}
 	}
-
+	
 	/**
-	 * Extracts files/folders from the assets/resources folder directly into
-	 * ${PARENT_FOLDER} (~/.expeditee)
-	 * 
-	 * @param force if true, resources will be extracted even if they have already been extracted before
+	 * Extracts files/folders from assets/resources-public and assets/resources-private 
+	 * to {Expeditee Home}/resources-public and {Expeditee Home}/resources-private respectively.
+	 * @param force  if true, resources will be extracted even ifthey have already been extracted before.
 	 */
-	public static void extractResources(boolean force)
-	{
-		File check = new File(FrameIO.PARENT_FOLDER + ".res");
+	public static void extractResources(boolean force) {
+		// Extract private resources
+		Path resourcesPrivate = Paths.get(FrameIO.PARENT_FOLDER).resolve("resources-private");
+		extractResources("org/expeditee/assets/resources-private", resourcesPrivate, force);
 		
-		if(!force && check.exists()) {
+		// Extract public resources
+		Path resourcesPublic = Paths.get(FrameIO.PARENT_FOLDER).resolve("resources-public");
+		extractResources("org/expeditee/assets/resources-public", resourcesPublic, force);
+	}
+	
+	private static void extractResources(String source, Path destination, boolean force) {
+		// If resources have already been extracted, and we are not forcing the extraction, there is nothing to do.
+		if (!force && destination.resolve(".res").toFile().exists()) {
 			return;
 		}
 		
-		System.out.println("Extracting/Installing resources:");
+		System.out.println("Extracting/Installing resources to: " + destination.getFileName());
 		
-		try	{
-			check.getParentFile().mkdirs();
-			check.createNewFile();
-
-			ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
-			URL docURL = classLoader.getResource("org/expeditee/assets/resources");
-
-			// copy files from the jar file to the profile folder
-			if (docURL.getProtocol().equals("jar")) {
-				JarURLConnection ju_connection=(JarURLConnection)docURL.openConnection();
-				JarFile jf =ju_connection.getJarFile();
+		// Create the destination
+		destination.getParent().toFile().mkdirs();
+		
+		ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
+		URL resourceUrl = classLoader.getResource(source);
+		if (resourceUrl.getProtocol().equals("jar")) {
+			try {
+				JarURLConnection ju_connection = (JarURLConnection) resourceUrl.openConnection();
+				JarFile jf = ju_connection.getJarFile();
 				Enumeration<JarEntry> jarEntries = jf.entries();
-				String res = "org/expeditee/assets/resources/";
-				int resLength = res.length();
-
-				ZipEntry ze;
-
-				while(jarEntries.hasMoreElements()) {
-					ze = jarEntries.nextElement();
-					if(!ze.getName().startsWith(res)) {
-						continue;
-					}
-					File out = new File(FrameIO.PARENT_FOLDER + ze.getName().substring(resLength));
-					// System.out.println("Didn't crash here " + out.getPath());
-					//					if(out.exists()) {
-					//						continue;
-					//					}
-					if(ze.isDirectory()) {
-						// System.out.println(out.getPath() + " IS DIRECTORY");
-						out.mkdirs();
-						continue;
-					}
-					FileOutputStream fOut = null;
-					InputStream fIn = null;
-					try {
-						// System.out.println(out.getPath());
-						fOut =  new FileOutputStream(out);
-						fIn = classLoader.getResourceAsStream(ze.getName());
-						byte[] bBuffer = new byte[1024];
-						int nLen;
-						while ((nLen = fIn.read(bBuffer)) > 0) {
-							fOut.write(bBuffer, 0, nLen);
-						}
-						fOut.flush();
-					} catch (Exception e) {
-						e.printStackTrace();
-					} finally {
-						if(fOut != null) {
-							fOut.close();
-						}
-						if(fIn != null) {
-							fIn.close();
-						}
-					}
-				}
-
-				// Copy files from the source folder to the profile folder
-			} else if (docURL.getProtocol().equals("bundleresource")) {
-				final URLConnection urlConnection = docURL.openConnection();
-				final Class<?> c = urlConnection.getClass();
-				final java.lang.reflect.Method toInvoke = c.getMethod("getFileURL");
-				final URL fileURL = (URL)toInvoke.invoke(urlConnection);
-				extractResourcesFromFolder(new File(fileURL.getPath()));
-			} else {
-				File folder = new File(docURL.toURI().getPath());
-				extractResourcesFromFolder(folder);
-			}
-		}
-		catch (Exception e) {
-			e.printStackTrace();
-		}
-	}
-
-	private static void extractResourcesFromFolder(File folder) throws IOException
-	{
+				extractFromJarFile(classLoader, jarEntries, source, destination);
+			} catch (IOException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Exception whilst extracting resources from Jar File.  Message: " + e.getMessage());
+			}
+		} else if (resourceUrl.getProtocol().equals("bundleresource")) {
+			try {
+				URLConnection urlConnection = resourceUrl.openConnection();
+				Class<?> c = urlConnection.getClass();
+				java.lang.reflect.Method toInvoke = c.getMethod("getFileURL");
+				URL fileURL = (URL) toInvoke.invoke(urlConnection);
+				extractResourcesFromFolder(new File(fileURL.getPath()), source, destination);
+			} catch (IOException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Problem opening connection to bundleresource.  Message: " + e.getMessage());
+			} catch (NoSuchMethodException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Unable to find method URLConnection::getFileURL.  Message: " + e.getMessage());
+			} catch (InvocationTargetException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Problem invoking URLConnection::getFileURL.  Message: " + e.getMessage());
+			} catch (IllegalAccessException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Problem invoking URLConnection::getFileURL.  Message: " + e.getMessage());
+			}
+		} else { 
+			try {
+				File folder = new File(resourceUrl.toURI().getPath());
+				extractResourcesFromFolder(folder, source, destination);
+			} catch (URISyntaxException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Problem converting URL to URI.  Message: " + e.getMessage());
+			} catch (IOException e) {
+				System.err.println("Error: FrameUtils::extractResources.  Exception whilst extracting resources from folder.  Message: " + e.getMessage());
+			}
+		}
+		
+		// Create the .res file to signal completion
+		try {
+			destination.resolve(".res").toFile().createNewFile();
+		} catch (IOException e) {
+			System.err.println("Error: FrameUtils::extractResources.  Unable to create the .res file to flag that resources have been extracted.  Message: " + e.getMessage());
+		}
+	}
+
+	private static void extractFromJarFile(ClassLoader classLoader, Enumeration<JarEntry> jarEntries, String source, Path destination) throws IOException {
+		while (jarEntries.hasMoreElements()) {
+			ZipEntry ze = jarEntries.nextElement();
+			if (!ze.getName().startsWith(source)) {
+				continue;
+			}
+			File out = destination.resolve(ze.getName().substring(source.length())).toFile();
+			if (ze.isDirectory()) {
+				out.mkdirs();
+				continue;
+			}
+			FileOutputStream fOut = null;
+			InputStream fIn = null;
+			try {
+				fOut = new FileOutputStream(out);
+				fIn = classLoader.getResourceAsStream(ze.getName());
+				byte[] bBuffer = new byte[1024];
+				int nLen;
+				while ((nLen = fIn.read(bBuffer)) > 0) {
+					fOut.write(bBuffer, 0, nLen);
+				}
+				fOut.flush();
+			} catch (Exception e) {
+				e.printStackTrace();
+			} finally {
+				if (fOut != null) {
+					fOut.close();
+				}
+				if (fIn != null) {
+					fIn.close();
+				}
+			}
+		}
+	}
+
+	private static void extractResourcesFromFolder(File folder, String source, Path destination) throws IOException {
 		LinkedList<File> items = new LinkedList<File>();
 		items.addAll(Arrays.asList(folder.listFiles()));
 		LinkedList<File> files = new LinkedList<File>();
-		String res = "org" + File.separator + "expeditee" + File.separator + "assets" + File.separator + "resources";
-		int resLength = res.length();
 
 		while (items.size() > 0) {
 			File file = items.remove(0);
-			if(file.isFile()) {
-				if(!file.getName().contains(".svn")) {
+			if (file.isFile()) {
+				if (!file.getName().contains(".svn")) {
 					files.add(file);
 				}
@@ -2003,9 +1939,8 @@
 		}
 		for (File file : files) {
-			System.out.println(file.getPath());
-			File out = new File(FrameIO.PARENT_FOLDER + file.getPath().substring(file.getPath().indexOf(res) + resLength));
-			//		if(out.exists()) {
-			//			continue;
-			//		}
+			String path = file.getPath();
+			System.out.println(path);
+			Path relativize = folder.toPath().relativize(Paths.get(file.getPath()));
+			File out = destination.resolve(relativize).toFile();
 			copyFile(file, out, true);
 		}
@@ -2017,10 +1952,9 @@
 	 * @throws IOException
 	 */
-	public static void copyFile(File src, File dst, boolean overWrite) throws IOException
-	{
-		if(!overWrite && dst.exists()) {
+	public static void copyFile(File src, File dst, boolean overWrite) throws IOException {
+		if (!overWrite && dst.exists()) {
 			return;
 		}
-		
+
 		dst.getParentFile().mkdirs();
 		FileOutputStream fOut = null;
@@ -2039,8 +1973,8 @@
 			e.printStackTrace();
 		} finally {
-			if(fOut != null) {
+			if (fOut != null) {
 				fOut.close();
 			}
-			if(fIn != null) {
+			if (fIn != null) {
 				fIn.close();
 			}
@@ -2048,11 +1982,9 @@
 	}
 
-	public static Text getLastEdited()
-	{
+	public static Text getLastEdited() {
 		return LastEdited;
 	}
 
-	public static Collection<Text> getCurrentTextItems()
-	{
+	public static Collection<Text> getCurrentTextItems() {
 		Collection<Text> currentTextItems = new LinkedHashSet<Text>();
 		Collection<Item> currentItems = getCurrentItems(null);
Index: trunk/src/org/expeditee/importer/pdfImporter.java
===================================================================
--- trunk/src/org/expeditee/importer/pdfImporter.java	(revision 1241)
+++ trunk/src/org/expeditee/importer/pdfImporter.java	(revision 1242)
@@ -77,5 +77,5 @@
 		}
 		
-		final String framesetPath = frameset.getPath()+name+File.separator;
+		final String framesetPath = frameset.getFramesetPath();
 		
 		System.out.println("PATH = " + framesetPath);
Index: trunk/src/org/expeditee/io/DefaultFrameReader.java
===================================================================
--- trunk/src/org/expeditee/io/DefaultFrameReader.java	(revision 1241)
+++ trunk/src/org/expeditee/io/DefaultFrameReader.java	(revision 1242)
@@ -89,4 +89,5 @@
 			_FrameTags.put('B', Frame.class.getMethod("setBackgroundColor",	pColor));
 			_FrameTags.put('K', Frame.class.getMethod("setEncryptionLabel", pString));
+			_FrameTags.put('T', Frame.class.getMethod("addToData", pString));
 
 			// Note: As of 26/11/18 there are no unused letter item tags.  Use other characters.
Index: trunk/src/org/expeditee/io/DefaultFrameWriter.java
===================================================================
--- trunk/src/org/expeditee/io/DefaultFrameWriter.java	(revision 1241)
+++ trunk/src/org/expeditee/io/DefaultFrameWriter.java	(revision 1242)
@@ -78,4 +78,5 @@
 			_FrameTags.put('B', Frame.class.getMethod("getBackgroundColor"));
 			_FrameTags.put('K', Frame.class.getMethod("getEncryptionLabel"));
+			_FrameTags.put('T', Frame.class.getMethod("getData"));
 			
 			// Note: As of 26/11/18 there are no unused letter item tags.  Use other characters.
Index: trunk/src/org/expeditee/io/ExpReader.java
===================================================================
--- trunk/src/org/expeditee/io/ExpReader.java	(revision 1241)
+++ trunk/src/org/expeditee/io/ExpReader.java	(revision 1242)
@@ -29,4 +29,5 @@
 import org.expeditee.core.Point;
 import org.expeditee.gui.Frame;
+import org.expeditee.gui.FrameIO;
 import org.expeditee.items.Constraint;
 import org.expeditee.items.Dot;
@@ -213,4 +214,5 @@
 		//newFrame.refreshItemPermissions();
 		_reader.close();
+		FrameIO.setSavedProperties(newFrame);
 		newFrame.setChanged(false);
 
@@ -344,3 +346,20 @@
 		return -1;
 	}
+	
+	public static String redirectTo(String fullPath) {
+		try {
+			BufferedReader reader = new BufferedReader(new FileReader(fullPath));
+			String next = "";
+			while (reader.ready() && !(next = reader.readLine()).equals("Z")) {
+				if (next.startsWith("REDIRECT:")) {
+					String redirectTo = next.replace("REDIRECT:", "");
+					reader.close();
+					return redirectTo;
+				}
+			}
+			reader.close();
+		} catch (Exception e) {
+		}
+		return null;
+	}
 }
Index: trunk/src/org/expeditee/io/HTMLWriter.java
===================================================================
--- trunk/src/org/expeditee/io/HTMLWriter.java	(revision 1241)
+++ trunk/src/org/expeditee/io/HTMLWriter.java	(revision 1242)
@@ -28,5 +28,4 @@
 import org.expeditee.gio.EcosystemManager;
 import org.expeditee.gio.GraphicsManager;
-import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.items.FramePicture;
@@ -104,5 +103,5 @@
 			}
 			if (filesFolder.equals("")) {
-				filesFolder = "../" + FrameIO.IMAGES_FOLDER;
+				filesFolder = "../images/";
 			}
 		}
